<template>
  <div
    class="versions-sidebar border rounded"
    :class="{ disabled: disabled }"
  >
    <div class="text-center p-4 border-bottom">
      <h2>Versions List</h2>
      <b-button-toolbar class="justify-content-center">
        <b-button-group
          v-if="versions.length"
          size="sm"
        >
          <b-button
            v-if="latestVersionId"
            :disabled="selectedVersionId === latestVersionId || disabled"
            variant="primary"
            @click="$emit('update:selectedVersionId', latestVersionId)"
          >
            Latest
            {{ selectedVersionId === latestVersionId ? ' ✓' : '' }}
          </b-button>
          <b-button
            v-if="enabledVersionId"
            :disabled="selectedVersionId === enabledVersionId || disabled"
            variant="success"
            @click="$emit('update:selectedVersionId', enabledVersionId)"
          >
            Enabled
            {{ selectedVersionId === enabledVersionId ? ' ✓' : '' }}
          </b-button>
        </b-button-group>
      </b-button-toolbar>
    </div>
    <b-list-group
      class="versions-list overflow-auto"
      flush
    >
      <p
        v-if="!versions.length"
        class="text-secondary p-5"
      >
        No versions to show.
        Any version added to this filter will be listed here.
      </p>
      <b-list-group-item
        v-for="version in versions"
        :key="version.id"
        :active="version.id === selectedVersionId"
        :disabled="disabled"
        class="bg-light py-3"
        button
        @click="$emit('update:selectedVersionId', version.id)"
      >
        <h5 class="font-weight-bold mb-0">
          Version #{{ version.id }}
          <span
            class="status d-inline-block border border-secondary rounded-circle ml-1 mb-n1"
            :class="`bg-${getVersionVariant(version)}`"
          />
        </h5>
        <small class="text-muted">{{ formatISODate(version.created_at) }}</small>
      </b-list-group-item>
    </b-list-group>
  </div>
</template>

<script lang="ts">
import Vue, { PropOptions } from 'vue';
import { STATUS_METADATA } from '@/common/constants';
import { FilterVersion } from '@/common/types';

export default Vue.extend({
  props: {
    disabled: {
      default: false,
      type: Boolean,
    },
    enabledVersionId: {
      default: '',
      type: String,
    },
    latestVersionId: {
      default: '',
      type: String,
    },
    selectedVersionId: {
      default: '',
      type: String,
    },
    versions: {
      required: true,
      type: Array,
    } as PropOptions<FilterVersion[]>,
  },

  methods: {
    getVersionVariant(version: FilterVersion) {
      const { status } = version;
      return STATUS_METADATA[status]?.variant;
    },
  },
});
</script>

<style scoped>
h2 {
  font-size: 1.2em;
  font-weight: bold;
}
.versions-sidebar.disabled {
  opacity: 0.5;
}
.versions-list h5 {
  font-size: 0.9rem;
}
.versions-list .status {
  width: 1rem;
  height: 1rem;
}
.list-group-item.active {
  color: #495057;
  background-color: rgba(0, 118, 182, 0.2) !important;
  border-color: rgba(0, 118, 182, 0.2);
}
.bg-primary {
  background-color: rgba(0, 118, 182, 0.7) !important;
}
.bg-secondary {
  background-color: rgba(119, 119, 119, 0.5) !important;
}
.bg-danger {
  background-color: rgba(235, 87, 87, 0.8) !important;
}
.bg-success {
  background-color: rgba(82, 148, 88, 0.7) !important;
}
.bg-warning {
  background-color: #F2DDC1 !important;
}
@media (min-width: 576px) {
  .versions-sidebar {
    border-left: 0 !important;
    /*
     * Sidebar needs a fixed height to enable scrolling.
     * Since height of sibling is variable, the following values
     * are estimates for the most common scenario
     */
    height: calc(40em + 172px);
    overflow-y: auto;
  }
}
</style>
